Index: trunk/LMDZ.MARS/libf/aeronomars/jthermcalc.F
===================================================================
--- trunk/LMDZ.MARS/libf/aeronomars/jthermcalc.F	(revision 633)
+++ trunk/LMDZ.MARS/libf/aeronomars/jthermcalc.F	(revision 635)
@@ -361,23 +869,147 @@
 
 
-c************************************************
-c      co2,119.6,202.5
-c************************************************
-
-      do indexint=25,31
-         do i=1,nz
-            aux2(nz-i+1) = co2colx(i) + o2colx(i)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsint(indexint,1,nz2-i+1)
-            aux4(i) = c12(nz2-i+1)
-         enddo
-         call interpfast 
-     $        ( aux1, aux2, nz,  aux3, aux4, nz2 , limdown , limup )
-         do i=1,nz
-           if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
-               jfotsout(indexint,1,i) = aux1(nz-i+1)
-     $            *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))*
-     $           (1+alfa(indexint,i)*(t2(i)-t0(i)))
+c**************************************************
+c     n2, 90.9-119.5nm
+c**************************************************
+     
+      do indexint=17,24
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = o2colx(i) + co2colx(i) + n2colx(i) +
+     $           nocolx(i) + cocolx(i) + no2colx(i)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,8,nz2-i+1)
+            aux4(i) = c17_24(nz2-i+1)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
+            jfotsout(indexint,8,i) = aux1(nlayermx-i+1)
+            if(indexint.eq.24) then
+          if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
+               jfotsout(indexint,8,i) = aux1(nlayermx-i+1)
+     $            *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
+               else
+                  jfotsout(indexint,8,i)=0.
+               end if
+            end if
+         enddo
+      end do
+
+
+c**************************************************
+c     co, 90.9-119.5nm
+c**************************************************
+     
+      do indexint=17,24
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = o2colx(i) + co2colx(i) + n2colx(i) +
+     $           nocolx(i) + cocolx(i) + no2colx(i)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,11,nz2-i+1)
+            aux4(i) = c17_24(nz2-i+1)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
+            jfotsout(indexint,11,i) = aux1(nlayermx-i+1)
+            if(indexint.eq.24) then
+          if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
+               jfotsout(indexint,11,i) = aux1(nlayermx-i+1)
+     $            *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
+               else
+                  jfotsout(indexint,11,i)=0.
+               end if
+            end if
+         enddo
+      end do
+
+
+      !Only if Nitrogen or ionospheric chemistry requested
+      if(chemthermod.ge.2) then
+
+c**************************************************
+c     no, 90.9-119.5nm
+c**************************************************
+     
+         do indexint=17,24
+            do i=1,nlayermx
+               aux2(nlayermx-i+1) = o2colx(i) + co2colx(i) + n2colx(i) +
+     $              nocolx(i) + cocolx(i) + no2colx(i)
+            end do
+            do i=1,nz2
+               aux3(i) = jabsifotsintpar(indexint,10,nz2-i+1)
+               aux4(i) = c17_24(nz2-i+1)
+            enddo
+            call interpfast 
+     $           (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+            do i=1,nlayermx
+               jfotsout(indexint,10,i) = aux1(nlayermx-i+1)
+               if(indexint.eq.24) then
+                  if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i)
+     $                 .lt.60.) then
+                     jfotsout(indexint,10,i) = aux1(nlayermx-i+1)
+     $             *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
+                  else
+                     jfotsout(indexint,10,i)=0.
+                  end if
+               end if
+            enddo
+         end do
+
+
+c**************************************************
+c     no2, 90.9-119.5nm
+c**************************************************
+     
+         do indexint=17,24
+            do i=1,nlayermx
+               aux2(nlayermx-i+1) = o2colx(i) + co2colx(i) + n2colx(i) +
+     $              nocolx(i) + cocolx(i) + no2colx(i)
+            end do
+            do i=1,nz2
+               aux3(i) = jabsifotsintpar(indexint,13,nz2-i+1)
+               aux4(i) = c17_24(nz2-i+1)
+            enddo
+            call interpfast 
+     $           (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+            do i=1,nlayermx
+               jfotsout(indexint,13,i) = aux1(nlayermx-i+1)
+               if(indexint.eq.24) then
+                  if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i)
+     $                 .lt.60.) then
+                     jfotsout(indexint,13,i) = aux1(nlayermx-i+1)
+     $              *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
+                  else
+                     jfotsout(indexint,13,i)=0.
+                  end if
+               end if
+            enddo
+         end do
+
+         endif !Of chemthermod >= 2
+
+
+c**************************************************
+c      co2, 119.6-167.0nm
+c**************************************************
+
+      do indexint=25,29
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) + 
+     $           h2o2colx(i) + nocolx(i) + cocolx(i) + no2colx(i)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,1,nz2-i+1)
+            aux4(i) = c25_29(nz2-i+1)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
+          if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
+               jfotsout(indexint,1,i) = aux1(nlayermx-i+1)
+     $            *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
+     $           *(1+alfa(indexint,i)*(t2(i)-t0(i)))               
             else
                jfotsout(indexint,1,i) = 0.
@@ -387,21 +1019,22 @@
 
 
-c************************************************
-c      o2,119.6,202.5
-c************************************************
-
-      do indexint=25,31
-         do i=1,nz
-            aux2(nz-i+1) = co2colx(i) + o2colx(i)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsint(indexint,2,nz2-i+1)
-            aux4(i) = c12(nz2-i+1)
-         enddo
-         call interpfast 
-     $        ( aux1, aux2, nz,  aux3, aux4, nz2 , limdown , limup )
-         do i=1,nz
+c**************************************************
+c      o2, 119.6-167.0nm
+c**************************************************
+
+      do indexint=25,29
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) +
+     $           h2o2colx(i) + nocolx(i) + cocolx(i) + no2colx(i)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,2,nz2-i+1)
+            aux4(i) = c25_29(nz2-i+1)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
            if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
-            jfotsout(indexint,2,i) = aux1(nz-i+1)
+            jfotsout(indexint,2,i) = aux1(nlayermx-i+1)
      $            *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
             else
@@ -412,21 +1045,22 @@
 
 
-c************************************************
-c      h2o,119.6,202.5
-c************************************************
-
-      do indexint=25,31
-         do i=1,nz
-            aux2(nz-i+1) = co2colx(i) + o2colx(i)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsint(indexint,4,nz2-i+1)
-            aux4(i) = c12(nz2-i+1)
-         enddo
-         call interpfast 
-     $        ( aux1, aux2, nz,  aux3, aux4, nz2 , limdown , limup )
-         do i=1,nz
+c**************************************************
+c      h2o, 119.6-167.0nm
+c**************************************************
+
+      do indexint=25,29
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) +
+     $           h2o2colx(i) + nocolx(i) + cocolx(i) + no2colx(i)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,4,nz2-i+1)
+            aux4(i) = c25_29(nz2-i+1)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
            if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
-            jfotsout(indexint,4,i) = aux1(nz-i+1) 
+            jfotsout(indexint,4,i) = aux1(nlayermx-i+1)
      $            *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
             else
@@ -437,21 +1071,22 @@
 
 
-c************************************************
-c      h2o2,119.6,202.5
-c************************************************
-
-      do indexint=25,31
-         do i=1,nz
-            aux2(nz-i+1) = co2colx(i) + o2colx(i)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsint(indexint,6,nz2-i+1)
-            aux4(i) = c12(nz2-i+1)
-         enddo
-         call interpfast 
-     $        ( aux1, aux2, nz,  aux3, aux4, nz2 , limdown , limup )
-         do i=1,nz
+c**************************************************
+c      h2o2,119.6-167.0nm
+c**************************************************
+
+      do indexint=25,29
+         do i=1,nlayermx
+            aux2(nlayermx-i+1) = co2colx(i) + o2colx(i) + h2ocolx(i) +
+     $           h2o2colx(i) + nocolx(i) + cocolx(i) + no2colx(i)
+         end do
+         do i=1,nz2
+            aux3(i) = jabsifotsintpar(indexint,6,nz2-i+1)
+            aux4(i) = c25_29(nz2-i+1)
+         enddo
+         call interpfast 
+     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+         do i=1,nlayermx
            if(sigma(indexint,i)*alfa(indexint,i)*coltemp(i).lt.60.) then
-            jfotsout(indexint,6,i) = aux1(nz-i+1) 
+            jfotsout(indexint,6,i) = aux1(nlayermx-i+1)
      $            *exp(-sigma(indexint,i)*alfa(indexint,i)*coltemp(i))
             else
